/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System;using System.Collections;using System.Collections.Generic;using MVR.FileManagementSecure;using Random = UnityEngine.Random;namespace PluginIdea.DecalSystem{public class SliderTextureCtr : MonoBehaviour{public Action<Texture2D> onTexLoadedCallback;public Action<float> onTranslateProgressCallback;public Action<Texture2D, Texture2D> onTranslateAnimFinished;public Action<bool> onActiveStateChanged;private TextureSettings slideTextureSetting = new TextureSettings(){compress = true, linearColor = false};private List<string> playModes = new List<string>{"Random", "Sequence", "Sequence Inverse"};private List<int> randomPool = new List<int>();private List<string> imageList = new List<string>();private List<object> slideEffectUIs;private JSONStorableStringChooser playModeChooser;private JSONStorableBool isAutoPlay;private JSONStorableFloat switchingInterval;private JSONStorableUrl folderPath;private JSONStorableFloat translateDuration;private JSONStorableAction prevAction, nextAction;private JSONStorableBool isUseSlideEffect;private string currentFolderUrl;private GameObject loadingIcon;private DynamicDecal ower;public void Init(DynamicDecal ower){this.ower = ower;loadingIcon = SuperController.singleton.loadingIcon.Find("LoadingIconCanvas/LoadingIcon").gameObject;loadingIcon.SetActive(false);Utils.SetupSpacer(ower, 20, false);var space = Utils.SetupSpacer(ower, 30, false);var settingTitle = Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.SlideControlSubtitle), 35, true);playModeChooser = Utils.SetupStringChooser(ower, Location.GetStr(Location.PlaybackOrder), playModes, 1, true, ower.acs);isAutoPlay = Utils.SetupToggle(ower, Location.GetStr(Location.IsAutoPlay), true, true, ower.acs);var btn = Utils.SetupTwinButton(ower, Location.GetStr(Location.PrevImage), () =>{prevAction.actionCallback();}, Location.GetStr(Location.NextImage), () =>{nextAction.actionCallback();}, true, ower.acs);UIDynamicButton browserBtn;UIDynamicLabelInput folderLabelInput;folderPath = Utils.SetupFolderChooser(ower, Location.GetStr(Location.SetFolder), $"Custom/Assets/MyAssets", true, null, out browserBtn, out folderLabelInput);folderPath.setCallbackFunction = (url) =>{currentFolderUrl = url;if (string.IsNullOrEmpty(url)) return;string dir = FileManagerSecure.GetDirectoryName(url);List<string> files = new List<string>();Utils.GetAllSubFiles(dir, ref files);if (files.Count > 0){if (currentTex != null) GameObject.Destroy(currentTex);if (nextTex != null) GameObject.Destroy(nextTex);imageList.Clear();files.ForEach(p =>{if (p.EndsWith(".jpg") || p.EndsWith(".png") || p.EndsWith(".jpeg") || p.EndsWith(".tiff")){imageList.Add(p);}});if (imageList.Count <= 1){SuperController.LogError("The folder needs to contain at least two valid pictures!");return;}Utils.LoadTexture(imageList[imgIndex], slideTextureSetting, (tex) =>{currentTex = tex;isCurTexLoadFinished = true;OnTexLoadFinished();});Utils.LoadTexture(imageList[imgIndex + 1], slideTextureSetting, (tex) =>{nextTex = tex;isNextTexLoadFinished = true;OnTexLoadFinished();});imgIndex = 1;}};switchingInterval = Utils.SetupSliderFloat(ower, Location.GetStr(Location.SwitchInterval), 5f, 0.5f, 100, true, ower.acs);translateDuration = Utils.SetupSliderFloat(ower, Location.GetStr(Location.TransitionDuration), 1.5f, 0.1f, 5f, true, ower.acs);if (ower is DynamicDecal){nextAction = (ower as DynamicDecal).nextImgAction;prevAction = (ower as DynamicDecal).prevImgAction;}nextAction = Utils.SetupAction(ower, "NextImageAction", () =>{SetNextImgPlayIndex();SwitchImage();});prevAction = Utils.SetupAction(ower, "PrevImageAction", () =>{SetPrevImgPlayIndex();SwitchImage();});}private float timer;private void Update(){if (isAutoPlay != null && isAutoPlay.val && imageList.Count > 1){timer += Time.deltaTime;if (timer > switchingInterval.val){timer = 0;SwitchImage();}}}private Texture2D currentTex, nextTex;private bool isCurTexLoadFinished, isNextTexLoadFinished;int imgIndex = 0;private void SwitchImage(){if (nextTex == null){int nextImgIndex = imgIndex + 1;if (nextImgIndex == imageList.Count) nextImgIndex = 0;Utils.LoadTexture(imageList[nextImgIndex], slideTextureSetting, (tex) =>{nextTex = tex;isNextTexLoadFinished = true;OnTexLoadFinished();});}if (isAutoPlay.val){switch (playModeChooser.val){case "Random":                        SetRandomImgPlayIndex();break;case "Sequence":                        SetNextImgPlayIndex();break;case "Sequence Inverse":                        SetPrevImgPlayIndex();break;default:                        break;}}}private void SetPrevImgPlayIndex(){imgIndex--;if (imgIndex < 0) imgIndex = imageList.Count - 1;}private void SetNextImgPlayIndex(){imgIndex++;if (imgIndex == imageList.Count) imgIndex = 0;}private void SetRandomImgPlayIndex(){if (randomPool.Count == 0){for (int i = 0;i < imageList.Count;i++){randomPool.Add(i);}}int tmpindex = Random.Range(0, randomPool.Count);imgIndex = randomPool[tmpindex];randomPool.RemoveAt(tmpindex);}private void OnUpdate(float progress){if (onTranslateProgressCallback != null) onTranslateProgressCallback(progress);}private void OnTransitionAnimPlayFinished(){isNextTexLoadFinished = false;if (onTranslateAnimFinished != null) onTranslateAnimFinished(currentTex, nextTex);nextTex = null;}private void OnTexLoadFinished(){if (isCurTexLoadFinished && isNextTexLoadFinished){if (onTexLoadedCallback != null) onTexLoadedCallback(nextTex);iTween.ValueTo(gameObject, iTween.Hash("from", 0, "to", 1, "easetype", 21, "onupdate", "OnUpdate", "oncomplete", "OnTransitionAnimPlayFinished", "time", translateDuration.val));}}private void OnDestroy(){loadingIcon.SetActive(true);}}}